////////////////////////////////////////////////////////////////////
// Scratch

#include <qapplication.h>
#include <qwidget.h>
#include <qpntarry.h>
#include <qpainter.h>

#include "scratch.h"


#include "desktop.inc"

ScratchControl::ScratchControl(QWidget *parent, const char *name )
	: QWidget( parent, name, WStyle_Customize|WStyle_NoBorder )
{
	_desktop=new DeskWindow();
	_dragmode=FALSE; _width=1; _grabbed=FALSE;
	setGeometry(0,0,1,1);
}
ScratchControl::~ScratchControl() {}

void ScratchControl::mouseDoubleClickEvent(QMouseEvent* e)
{
	if (e->button() == LeftButton) {
		if ( ! _grabbed) { 
			grabMouse(); _grabbed=TRUE; 
		} else {
			releaseMouse(); _grabbed=FALSE; 
		}
	} else if (e->button() == RightButton) {
		close();
	}
}
void ScratchControl::mousePressEvent(QMouseEvent* e)
{
	if (!_grabbed) { return; }
	if (e->button() == LeftButton) {
		_pnt=mapToGlobal(e->pos());
		_dragmode=TRUE;
	}
}
void ScratchControl::mouseMoveEvent(QMouseEvent* e)
{
	QPoint npnt=mapToGlobal(e->pos());

	if (_dragmode) { int w=_width;
		QCOORD points[8] = { 
			npnt.x()-w,npnt.y(),  npnt.x()+w,npnt.y(),  
			_pnt.x()+w,_pnt.y(),  _pnt.x()-w,_pnt.y()  
		}; QPointArray pa(4,points);
		QPainter p(_desktop); 
		p.setPen(NoPen);
		p.setBrush(black);
		p.drawPolygon( pa ); 
	}

	_pnt=npnt;
}
void ScratchControl::mouseReleaseEvent(QMouseEvent* )
{
	if (_dragmode) { _dragmode=FALSE; }
}

int main(int argc,char **argv) {
	QApplication q(argc,argv);

	ScratchControl *c=new ScratchControl();
	q.setMainWidget(c);
	c->show();
	
	qApp->exec();
	return 0;
}
