////////////////////////////////////////////////////////////////////
// Shake-Mouse 

#include <qapplication.h>
#include <qobject.h>

#include <stdlib.h>

#include "shake.h"

int ShakeMouse::defaultDelay=50;
int ShakeMouse::defaultRadius=1;

ShakeMouse::ShakeMouse(bool enable, int delay, int radius)
{
	_enable=FALSE; _timerId=0;
	setParam(delay,radius);
	if (enable) { this->enable(); }
}
ShakeMouse::~ShakeMouse() { if (_timerId) disable(); }
void ShakeMouse::enable(bool enable) 
{
	if (enable) {
		if (! _timerId) { _timerId=startTimer( _delay ); }
	} else {
		if (_timerId) { killTimer(_timerId); }
	}
}
void ShakeMouse::setParam(int delay, int radius)
{
	_delay = (delay  != -1) ? delay  : defaultDelay ;
	_radius= (radius != -1) ? radius : defaultRadius;
}
void ShakeMouse::timerEvent(QTimerEvent *)
{
	int rad= (_radius+_radius+1) ;
	int dx=rand()% rad - _radius ;
	int dy=rand()% rad - _radius ;
	QCursor::setPos( QCursor::pos() + QPoint(dx,dy) );
}


int main(int argc,char **argv) {
	QApplication q(argc,argv);

	ShakeMouse sm(TRUE);

	qApp->exec();
	return 0;
}
